package client;

import com.sample.test.service.requesthandler.servicea.ServiceA;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.ws.WebServiceRef;

public class ServiceInvoker extends HttpServlet
{

    @WebServiceRef(wsdlLocation = "WEB-INF/wsdl/client/ServiceA/ServiceA.wsdl")
    private ServiceA service;

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException
    {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try
        {
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet ServiceInvoker</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet ServiceInvoker at " + request.getContextPath() + "</h1>");

            try
            { // Call Web Service Operation
                com.sample.test.service.requesthandler.servicea.ServiceAPortType port = service.getServiceAHttpPort();
                // TODO initialize WS operation arguments here
                com.sample.test.service.requesthandler.servicea.InvokeTest part1 = new com.sample.test.service.requesthandler.servicea.InvokeTest();
                part1.setMessage(1);
                com.sample.test.service.requesthandler.servicea.InvokeTestReply result = port.invokeTest(part1);
                out.println("Result = " + result);
            }
            catch (Exception ex)
            {
                // TODO handle custom exceptions here
                Logger.getLogger(ServiceInvoker.class.getName()).log(Level.SEVERE, null, ex);
            }

            out.println("</body>");
            out.println("</html>");
        }
        finally
        {
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException
    {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException
    {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     */
    public String getServletInfo()
    {
        return "Short description";
    }// </editor-fold>
}
